# 3.56.1
Starting from this version, RTC SDK for iOS no longer supports the armv7 architecture, as required by the Apple App Store. The minimum compatible version is iOS 11.
## New
1. Starting from this version, some features have been separated from the SDK and encapsulated into independent extensions. A new callback [onExtensionAccessError](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_event_handler/RTCVideoEventHandler/onExtensionAccessError.html) is added, which allows you to locate the extension that you failed to access.
2. You can set room-related attributes and other extra information with the new API [setRoomExtraInfo](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_room_api/RTCRoom/setRoomExtraInfo.html).
3. Adds a callback for user visibility setting results. See [onUserVisibilityChanged](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_room_event_handler/RTCRoomEventHandler/onUserVisibilityChanged.html).
4. Adds a new API [setLogConfig](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setLogConfig.html), with which you can set the local log parameters, including the logging level, directory, and the maximum cache space that can be used.
5. You can disable the automatic face exposure feature and the dynamic capture frame rate feature with the new APIs [enableCameraAutoExposureFaceMode](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/enableCameraAutoExposureFaceMode.html) and [setCameraAdaptiveMinimumFrameRate](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setCameraAdaptiveMinimumFrameRate.html).
6. Cellular enhanced communication is supported with the new API [setCellularEnhancement](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setCellularEnhancement.html).
7. Supports setting local proxies and other extra information with the new API [setLocalProxy](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setLocalProxy.html)
8. Adds new parameters which you can set while mixing streams on the server side.
    + Supports setting PayLoadType when sending SEI during stream mixing and pushing, and supports receiving SEI information when using specific players as the receiving end. See the APIs below:
        - [seiPayloadType](https://pub.dev/documentation/byteplus_rtc/latest/bytertc_cdn_stream/MixedStreamServerControlConfig/seiPayloadType.html)
        - [seiPayloadUuid](https://pub.dev/documentation/byteplus_rtc/latest/bytertc_cdn_stream/MixedStreamServerControlConfig/seiPayloadUuid.html)
    + Supports SEI content control. In previous versions, the stream contains all the SEI information by default. While in the new version, you can choose whether to send volume indication SEI only, which significantly reduces performance consumption in scenarios where high-frequency volume information needs to be sent. See the APIs below:
        - [enableVolumeIndication](https://pub.dev/documentation/byteplus_rtc/latest/bytertc_cdn_stream/MixedStreamServerControlConfig/enableVolumeIndication.html)
        - [seiContentMode](https://pub.dev/documentation/byteplus_rtc/latest/bytertc_cdn_stream/MixedStreamServerControlConfig/seiContentMode.html)
        - [isAddVolumeValue](https://pub.dev/documentation/byteplus_rtc/latest/bytertc_cdn_stream/MixedStreamServerControlConfig/isAddVolumeValue.html)
        - [volumeIndicationInterval](https://pub.dev/documentation/byteplus_rtc/latest/bytertc_cdn_stream/MixedStreamServerControlConfig/volumeIndicationInterval.html)
        - [talkVolume](https://pub.dev/documentation/byteplus_rtc/latest/bytertc_cdn_stream/MixedStreamServerControlConfig/talkVolume.html)
9. Supports setting the rotation angle of the remote video frame to be rendered with the new parameter `renderRotation` in [RTCSurfaceView](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_render_view/RTCSurfaceView-class.html).
10. Adds "clarity" to the basic beauty effects. This sub-item requires integration with the Effects SDK v4.4.2+. The default values for each beauty mode's intensity are adjusted as follows: 0.7 for brightening, 0.8 for smoothing, 0.5 for sharpening, and 0.7 for clarity. See [enableEffectBeauty](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/enableEffectBeauty.html) for the detailed description.

## Enhanced
1. Optimization for big conferences. After the [Audio Selection](https://console.byteplus.com/rtc/cloudRTC?tab=roomMode) is enabled, the publisher can choose to skip the Audio Selection. It is suitable for scenarios where the speeches of the specified users are expected to be heard all the time, such as the rooms with a host. For each appId, you should decide whether to enable Audio Selection instead of which room mode. Refer to [Audio Selection](https://docs.byteplus.com/en/byteplus-rtc/docs/113547) and the new API [setAudioSelectionConfig](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_room_api/RTCRoom/setAudioSelectionConfig.html).
2. Optimizes the spatial audio feature. Supports updating the position and orientation of the local user and a certain remote user in the rectangular coordinate system in the current room, as well as removing one or all remote users from the spatial audio effect. See the APIs:
    + [updatePosition](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_spatial_audio_api/RTCSpatialAudio/updatePosition.html) and [updateSelfOrientation](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_spatial_audio_api/RTCSpatialAudio/updateSelfOrientation.html) are deprecated and replaced by the new API [updateSelfPosition](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_spatial_audio_api/RTCSpatialAudio/updateSelfPosition.html).
    + [updateListenerPosition](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_spatial_audio_api/RTCSpatialAudio/updateListenerPosition.html) and [updateListenerOrientation](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_spatial_audio_api/RTCSpatialAudio/updateListenerOrientation.html) are deprecated and replaced by the new API [updateRemotePosition](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_spatial_audio_api/RTCSpatialAudio/updateRemotePosition.html).
    + Adds [removeRemotePosition](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_spatial_audio_api/RTCSpatialAudio/removeRemotePosition.html).
    + Adds [removeAllRemotePosition](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_spatial_audio_api/RTCSpatialAudio/removeAllRemotePosition.html).
3. For an Android App using RTC SDK to capture video internally,  if it goes to the background for a duration exceeding one minute and then returns to the foreground, RTC will automatically resume video capture without any additional operations.
4. You can get the pitch info of the local voice when you enable local audio property report. See the APIs below:
    + Call [enableAudioPropertiesReport](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/enableAudioPropertiesReport.html) to enable audio property report.
    + Get local audio property report through [onLocalAudioPropertiesReport](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_event_handler/RTCVideoEventHandler/onLocalAudioPropertiesReport.html).
5. Optimizes the error message returned when capturing snapshots on the client side. See the APIs below:
    + [takeLocalSnapshot](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/takeLocalSnapshot.html)
    + [takeRemoteSnapshot](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/takeRemoteSnapshot.html)

## Changelog
### Header file change
Enums/classes related to pushing stream to CDN are moved to "bytertc_cdn_stream.dart", which you should import into your project if relevant feature are used.

### API change
1. This version adds a return value for all APIs, through which the failed API call can be clearly identified and the cause of the failure can be located. For the meaning of the specific return value, refer to each API comment.
2. The data types of the parameters of [feedback](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/feedback.html) are changed.
3. The APIs used in the function of pushing mixed streams to CDN are renamed with the behavior logic remaining unchanged:
    + [startLiveTranscoding](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/startLiveTranscoding.html) is deprecated and replaced by [startPushMixedStreamToCDN](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/startLiveTranscoding.html).
    + [stopLiveTranscoding](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/startLiveTranscoding.html) is deprecated and replaced by [stopPushStreamToCDN](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/startLiveTranscoding.html).
    + [updateLiveTranscoding](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/startLiveTranscoding.html) is deprecated and replaced by [updatePushMixedStreamToCDN](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/startLiveTranscoding.html).
4. Splits the audio mixing class into audio effect management class and music management class. Generally, for audio effect less than 20 seconds, use audio effect class; for audio files longer than 20 seconds or PCM data, use music management class. See the APIs:
    + [AudioMixingManager](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/audioMixingManager.html) is deprecated and replaced by [getAudioEffectPlayer](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/getAudioEffectPlayer.html) and [getMediaPlayer](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/getMediaPlayer.html).
5. The behavior of the API [startAudioRecording](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/startAudioRecording.html) changes. In previous versions, this API only supports calling after joining a room. Starting from this version, this API can be called both before and after joining the room. If called before joining the room, the recording task will not automatically stop after leaving the room. If called after joining the room, the recording task will automatically stop after leaving the room.

### Callback change
1. Adds an input parameter for the [onLogout](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_event_handler/RTCVideoEventHandler/onLogout.html) callback to describe the reason why the user logs out. See [LogoutReason](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_rts_defines/LogoutReason.html) for the details.

### Class/Enum change
1. The `overScreenPublishLimit` and `overVideoPublishLimit` in [ErrorCode](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_media_defines/ErrorCode.html) is deprecated and replaced by `overStreamPublishLimit`.
2. Adds new values in [UserMessageSendResult](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_rts_defines/UserMessageSendResult.html) for message sending failure from the client to the app server:
    + `e2bsReturnFailed`: The app server failed to receive the message sent from the client.
    + `e2bsReturnFailed`: The app server received the message sent by the client, but failed to response.

# 3.51.1
## New
1. `captureDetectHowling` warning is added into [MediaDeviceWarning](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_media_defines/MediaDeviceWarning.html), which will be triggered in the following circumstances:
    - Howling is detected in room modes that do not support howling suppression.
    - Unsuppressed howling is detected in room modes that support howling suppression.
2. From iPadOS, you can use Stage Manger to organize Apps and Windows. If your App is not in the center, you can get informed by [onVideoDeviceStateChanged](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_event_handler/RTCVideoEventHandler/onVideoDeviceStateChanged.html). Refer to [Resume Audio/Video Call](https://docs.byteplus.com/en/byteplus-rtc/docs/111590).
3. Set a static picture as a replacement for the locally captured video stream by calling the new API [setDummyCaptureImagePath](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setDummyCaptureImagePath.html).
4. Switch the BlueTooth communication mode between the iOS device and earphones when RTC works on media scenarios by calling the new API [setBluetoothMode](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setBluetoothMode.html).
5. In multi-room scenarios, you can adjust the volume of all users in one room at once with the new API [setRemoteRoomAudioPlaybackVolume](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_room_api/RTCRoom/setRemoteRoomAudioPlaybackVolume.html).
6. By calling the new API [setNoAttenuationFlags](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_range_audio_api/RTCRangeAudio/setNoAttenuationFlags.html), you can set a team to the mode that the teammates can talk without attenuation, despite the range audio feature being enabled.
7. Supports detecting background music during the call and protecting the sound quality of the music. Please contact the technical support team if you need this feature.
8. Adds [onPublishPrivilegeTokenWillExpire](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_room_event_handler/RTCRoomEventHandler/onPublishPrivilegeTokenWillExpire.html) and [onSubscribePrivilegeTokenWillExpire](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_room_event_handler/RTCRoomEventHandler/onSubscribePrivilegeTokenWillExpire.html) callbacks, which will be triggered when the publishing/subscribing privilege of your Token is about to expire. After receiving the callback, you must re-acquire and update the relevant privileges of the Token to ensure normal audio/video calls. Contact the technical support team if you need this feature.
9. Supports some new voice reverb types. For all the types, see [VoiceReverbType](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_audio_defines/VoiceReverbType.html).
10. Supports setting the equalization and reverb effect of the locally captured audio. See the APIs below:
    - [setLocalVoiceEqualization](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setLocalVoiceEqualization.html)
    - [setLocalVoiceReverbParam](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setLocalVoiceReverbParam.html)
    - [enableLocalVoiceReverb](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/enableLocalVoiceReverb.html)
11. Supports stopping, pausing, and resuming playback of all audio files. See the APIs below:
    - [stopAllAudioMixing](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_audio_mixing_api/RTCAudioMixingManager/stopAllAudioMixing.html)
    - [pauseAllAudioMixing](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_audio_mixing_api/RTCAudioMixingManager/pauseAllAudioMixing.html)
    - [resumeAllAudioMixing](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_audio_mixing_api/RTCAudioMixingManager/resumeAllAudioMixing.html)
12. Supports examining the echo-cancellation ability of local audio devices before or during an RTC call. See the APIs below:
    - [startHardwareEchoDetection](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/startHardwareEchoDetection.html)
    - [stopHardwareEchoDetection](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/stopHardwareEchoDetection.html)
13. Adds a new feature allowing users to magnify the view of local videos and then move around. We recommend this feature as the method for local video control by considering the diversity of cameras on all the devices and the difficulties of adapting them all. See the APIs below:
    - [setVideoDigitalZoomConfig](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setVideoDigitalZoomConfig.html)
    - [setVideoDigitalZoomControl](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setVideoDigitalZoomControl.html)
    - [startVideoDigitalZoomControl](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/startVideoDigitalZoomControl.html)
    - [stopVideoDigitalZoomControl](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/stopVideoDigitalZoomControl.html)
14. Automatically adapt the Ambient Noise Suppression(ANS) algorithm according to the business scenario selected when entering the room by calling the new API [setAnsMode](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setAnsMode.html). You can also set the ANS mode manually during the call. 
15. Adjust the volume of the remote public audio for local playback by calling the new API [setPublicStreamAudioPlaybackVolume](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setPublicStreamAudioPlaybackVolume.html).

## Enhanced
1. When getting local and remote volume information by calling [enableAudioPropertiesReport](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/enableAudioPropertiesReport.html), you can make the volume curve smoother with "smooth" and get information about locally mixing audio with "audio_report_mode".

2. [sendSEIMessage](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/sendSEIMessage.html) includes a new parameter "SEICountPerFrame". When you send multiple SEI messages in 1 frame, they will be sent together in the next frame.

## Changelog
### Header file change
The original header file "bytertc_common_defines.dart" is split into "bytertc_media_defines.dart" and "bytertc_rts_defines.dart", both of which you should import into your project if needed.
### API change
1. [registerFaceDetectionObserver](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/registerFaceDetectionObserver.html) is replaced by [enableFaceDetection](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_effect_api/RTCVideoEffect/enableFaceDetection.html) and [disableFaceDetection](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_effect_api/RTCVideoEffect/disableFaceDetection.html), decoupling face detection and video effects to improve usability.
2. The parameter type of [setScreenVideoEncoderConfig](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setScreenVideoEncoderConfig.html) changes from "VideoEncoderConfig" to "ScreenVideoEncoderConfig".
3. Video effect related APIs are moved from `RTCVideo` class to `RTCVideoEffect` class:
    - [initCVResource](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_effect_api/RTCVideoEffect/initCVResource.html) replaces [checkVideoEffectLicense](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/checkVideoEffectLicense.html) and [setVideoEffectAlgoModelPath](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setVideoEffectAlgoModelPath.html)；
    - [enableVideoEffect](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_effect_api/RTCVideoEffect/enableVideoEffect.html) and [disableVideoEffect](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_effect_api/RTCVideoEffect/disableVideoEffect.html) replace [enableVideoEffect](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/enableVideoEffect.html)；
    - [setEffectNodes](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_effect_api/RTCVideoEffect/setEffectNodes.html) replaces [setVideoEffectNodes](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setVideoEffectNodes.html)；
    - [updateEffectNode](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_effect_api/RTCVideoEffect/updateEffectNode.html) replaces [updateVideoEffectNode](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/updateVideoEffectNode.html)；
    - [enableVirtualBackground](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_effect_api/RTCVideoEffect/enableVirtualBackground.html) and [disableVirtualBackground](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_effect_api/RTCVideoEffect/disableVirtualBackground.html) replace [setBackgroundSticker](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setBackgroundSticker.html)；
    - [setColorFilter](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_effect_api/RTCVideoEffect/setColorFilter.html) replaces [setVideoEffectColorFilter](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setVideoEffectColorFilter.html)；
    - [setColorFilterIntensity](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_effect_api/RTCVideoEffect/setColorFilterIntensity.html) replaces [setVideoEffectColorFilterIntensity](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setVideoEffectColorFilterIntensity.html)；
4. Return value type change:
    - The return type of the following APIs is changed to "int", the values of which are listed in [ReturnStatus](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_media_defines/ReturnStatus.html): `updateToken`，`setRemoteVideoConfig`，`subscribeStream`，`unsubscribeStream`，`subscribeScreen`，`unsubscribeScreen`，`setVoiceChangerType`，`setVoiceReverbType`；
    - The return type of the following APIs is changed to "void": `setMultiDeviceAVSync`，`setLocalVideoMirrorType`，`setVideoRotationMode`，`setAudioRoute`，`enableSimulcastMode`，`setPublishFallbackOption`，`setSubscribeFallbackOption`.
5. `getSdkVersion` is changed to [getSDKVersion](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/getSDKVersion.html).
6. The behavior of [setAudioRoute](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setAudioRoute.html) changed. You can use devices with media mode only as the audio route device.

### Callback change
1. [onPublicStreamSEIMessageReceived](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_event_handler/RTCVideoEventHandler/onPublicStreamSEIMessageReceived.html) includes a new parameter "sourceType".
2. The `RTCRangeAudioObserver` callback class is deprecated. Before this version, When you use range audio with manual audio subscription, you must set the attenuation index based on the return value of "RTCRangeAudioObserver". From this version, you can set the attenuation model by calling [setAttenuationModel](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_range_audio_api/RTCRangeAudio/setAttenuationModel.html).
3. [onRemoteAudioStateChanged](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_event_handler/RTCVideoEventHandler/onRemoteAudioStateChanged.html) and [onRemoteVideoStateChanged](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_event_handler/RTCVideoEventHandler/onRemoteVideoStateChanged.html) are deprecated with no alternatives.
4. [onLocalAudioStateChanged](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_event_handler/RTCVideoEventHandler/onLocalAudioStateChanged.html) and [onLocalVideoStateChanged](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_event_handler/RTCVideoEventHandler/onLocalVideoStateChanged.html) are replaced by [onAudioDeviceStateChanged](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_event_handler/RTCVideoEventHandler/onAudioDeviceStateChanged.html) and [onVideoDeviceStateChanged](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_event_handler/RTCVideoEventHandler/onVideoDeviceStateChanged.html).

### Class/Enum change
1. [FaceDetectionResult](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_defines/FaceDetectionResult-class.html) includes a new member "frameTimestampUs".
2. [UserMessageSendResult](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_rts_defines/UserMessageSendResult.html) includes a new value "exceedQPS".
3. [RoomMessageSendResult](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_rts_defines/RoomMessageSendResult.html) includes a new value "exceedQPS".
4. The type of the variables in [Position](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_audio_defines/Position-class.html) representing spatial coordinates in spatial audio functions changes from "int" to "double".
5. The configuration of the default mode "communication" in [RoomProfile](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_media_defines/RoomProfile.html) changes from corresponding to "chatRoom" to corresponding to "meeting".
6. The type of the `errorCode` in [onPushPublicStreamResult](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_event_handler/RTCVideoEventHandler/onPushPublicStreamResult.html) and [onPlayPublicStreamResult](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_event_handler/RTCVideoEventHandler/onPlayPublicStreamResult.html) changes from "int" to [PublicStreamErrorCode](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_media_defines/PublicStreamErrorCode.html).
7. The value "unknown" in [AudioRoute](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_audio_defines/AudioRoute.html) is changed to "routeDefault".
8. [AudioScenario](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_audio_defines/AudioScenario.html) The mapping of audio routing and publish-subscribe state to volume type has changed. See the documentation of the data structure for the latest mapping.

# 3.45.2
## New
1. [AudioScenario](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_audio_defines/AudioScenario.html) includes "highQualityChat" mode.
2. Get the actual mixing length of the audio file by calling the new API [getAudioMixingPlaybackDuration](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_audio_mixing_api/RTCAudioMixingManager/getAudioMixingPlaybackDuration.html), regardless of pausing, jumping, changing speed, and stuck.
3. With the new pair of APIs [subscribeAllStreams](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_room_api/RTCRoom/subscribeAllStreams.html) and [unsubscribeAllStreams](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_room_api/RTCRoom/unsubscribeAllStreams.html), you can subscribe or unsubscribe to all users by one call. We recommend using them in the scenario that requires a fixed number of publishers.
4. Set the default volume during audio mixing on mobile with the new API [setAllAudioMixingVolume](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_audio_mixing_api/RTCAudioMixingManager/setAllAudioMixingVolume.html).
5. Get the snapshot of the local/remote screen on the client with the new APIS [takeLocalSnapshot](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/takeLocalSnapshot.html) and [takeRemoteSnapshot](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/takeRemoteSnapshot.html).
6. [NetworkQuality](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_common_defines/NetworkQuality.html) includes a new value "down" which can reflect the disconnection status of the local network.

# 3.45.1

* Fixed a few bugs.

# 3.44.1

* Flutter for BytePlusRTC SDK release.
