// Copyright 2022 BytePlus Pte. Ltd.
// SPDX-License-Identifier: MIT

import 'dart:typed_data';

import 'bytertc_media_defines.dart';
import 'bytertc_rts_defines.dart';

/// Empty Callback
typedef EmptyCallbackType = void Function();

/// [stats]: CPU and memory information.
typedef OnSysStatsType = void Function(SysStats stats);

/// [stats]: Summary statistics in the room.
typedef OnRoomStatsType = void Function(RTCRoomStats stats);

/// [stats]: Media stream and network status statistics
typedef OnLocalStreamStatsType = void Function(LocalStreamStats stats);

/// [stats]: Media stream and network status statistics
typedef OnRemoteStreamStatsType = void Function(RemoteStreamStats stats);

/// [msgid]: ID of this message.
///
/// [error]: Text or binary message sending results.
typedef OnMessageSendResultType = void Function(
    int msgid, UserMessageSendResult error);

/// [uid]: ID of the user who send the message.
///
/// [message]: Contents of the received message.
typedef OnMessageReceivedType = void Function(String uid, String message);

/// [uid]: ID of the user who send the message. ID
///
/// [message]: Contents of the received message.
typedef OnBinaryMessageReceivedType = void Function(
    String uid, Uint8List message);

/// [localQuality]: Local network quality.
///
/// [remoteQualities]: Network quality of subscribed users.
typedef OnNetworkQualityType = void Function(NetworkQualityStats localQuality,
    List<NetworkQualityStats> remoteQualities);
