// Copyright 2022 BytePlus Pte. Ltd.
// SPDX-License-Identifier: MIT

// ignore_for_file: public_member_api_docs
import 'dart:typed_data';

import '../../api/bytertc_rts_defines.dart';
import 'bytertc_enum_convert.dart';

class OnMessageSendResultData {
  final int msgid;
  final UserMessageSendResult error;

  const OnMessageSendResultData({required this.msgid, required this.error});

  factory OnMessageSendResultData.fromMap(Map<dynamic, dynamic> map) {
    return OnMessageSendResultData(
        msgid: map['msgid'],
        error: (map['error'] as int).userMessageSendResult);
  }
}

class OnMessageReceivedData {
  final String uid;
  final String message;

  const OnMessageReceivedData({required this.uid, required this.message});

  factory OnMessageReceivedData.fromMap(Map<dynamic, dynamic> map) {
    return OnMessageReceivedData(uid: map['uid'], message: map['message']);
  }
}

class OnBinaryMessageReceivedData {
  final String uid;
  final Uint8List message;

  const OnBinaryMessageReceivedData({required this.uid, required this.message});

  factory OnBinaryMessageReceivedData.fromMap(Map<dynamic, dynamic> map) {
    return OnBinaryMessageReceivedData(
        uid: map['uid'], message: map['message']);
  }
}
