// Copyright 2022 BytePlus Pte. Ltd.
// SPDX-License-Identifier: MIT

// ignore_for_file: public_member_api_docs
import '../api/bytertc_face_detection.dart';

extension RTCFaceDetectionProcessor on RTCFaceDetectionObserver {
  void process(String methodName, Map<dynamic, dynamic> dic) {
    switch (methodName) {
      case 'onFaceDetectResult':
        final data = OnFaceDetectResultData.fromMap(dic);
        onFaceDetectResult?.call(data.result);
        break;
      default:
        break;
    }
  }
}

class OnFaceDetectResultData {
  final FaceDetectionResult result;

  const OnFaceDetectResultData({required this.result});

  factory OnFaceDetectResultData.fromMap(Map<dynamic, dynamic> map) {
    return OnFaceDetectResultData(
        result: FaceDetectionResult.fromMap(map['result']));
  }
}
